#########################
# Method 7: Calibration #
#########################

load("test.Rdata")
load("data_ELN_cat.RData")
pheno.train <- data_ELN_cat
outcome <- pheno.train$outcome

library(survival)

TIME <- as.numeric(pheno.test$uebleb)/365.25
EXIT <- pheno.test$exit

TIMETrain <- outcome[ ,1]/365.25
EXITTrain <- outcome[ ,2]


load("groups_test.Rdata")
load("groups_train.Rdata")



################################################################

par(mfrow=c(3, 3), oma=c(0, 3, 0, 0))


col = c("gray75", "gray55", "black")

dattest <- data.frame(TIME=TIME, EXIT=EXIT, score=group_pl_kat)
dattest <- dattest[complete.cases(dattest), ]
dattrain <- data.frame(TIME=TIMETrain, EXIT=EXITTrain, score=group_pl_kat_train)
dattrain <- dattrain[complete.cases(dattrain), ]

finalmodel <- coxph(Surv(TIME, EXIT)~score, data=dattrain)
predictions <- survfit(finalmodel, newdata=dattest)

plot(survfit(formula=Surv(TIME, EXIT)~score, data=dattest), col=col, lwd=2,
     yaxt="n", main="Priority-Lasso", xlab="Overall survival in years", ylab="Survival probability")
axis(2, las=2)
points(predictions$time, apply(predictions$surv[ , dattest$score==0], MARGIN=1, FUN=mean), col="gray75", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==1], MARGIN=1, FUN=mean), col="gray55", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==2], MARGIN=1, FUN=mean), lty=2, type="l", lwd=2)

##
dattest <- data.frame(TIME=TIME, EXIT=EXIT, score=group_pl_kat_cvoffset)
dattest <- dattest[complete.cases(dattest), ]
dattrain <- data.frame(TIME=TIMETrain, EXIT=EXITTrain, score=group_pl_kat_cvoffset_train)
dattrain <- dattrain[complete.cases(dattrain), ]

finalmodel <- coxph(Surv(TIME, EXIT)~score, data=dattrain)
predictions <- survfit(finalmodel, newdata=dattest)

plot(survfit(formula=Surv(TIME, EXIT)~score, data=dattest), col=col, lwd=2,
     yaxt="n", main="Priority-Lasso\n CV offset", xlab="Overall survival in years", ylab="Survival probability")
axis(2, las=2)
points(predictions$time, apply(predictions$surv[ , dattest$score==0], MARGIN=1, FUN=mean), col="gray75", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==1], MARGIN=1, FUN=mean), col="gray55", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==2], MARGIN=1, FUN=mean), lty=2, type="l", lwd=2)

##
dattest <- data.frame(TIME=TIME, EXIT=EXIT, score=group_lasso_kat)
dattest <- dattest[complete.cases(dattest), ]
dattrain <- data.frame(TIME=TIMETrain, EXIT=EXITTrain, score=group_lasso_kat_train)
dattrain <- dattrain[complete.cases(dattrain), ]

finalmodel <- coxph(Surv(TIME, EXIT)~score, data=dattrain)
predictions <- survfit(finalmodel, newdata=dattest)

plot(survfit(formula=Surv(TIME, EXIT)~score, data=dattest), col=col, lwd=2, 
     yaxt="n", main="Lasso", xlab="Overall survival in years", ylab="Survival probability")
axis(2, las=2)
points(predictions$time, apply(predictions$surv[ , dattest$score==0], MARGIN=1, FUN=mean), col="gray75", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==1], MARGIN=1, FUN=mean), col="gray55", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==2], MARGIN=1, FUN=mean), lty=2, type="l", lwd=2)

##
dattest <- data.frame(TIME=TIME, EXIT=EXIT, score=group_pl_ELN)
dattest <- dattest[complete.cases(dattest), ]
dattrain <- data.frame(TIME=TIMETrain, EXIT=EXITTrain, score=group_pl_ELN_train)
dattrain <- dattrain[complete.cases(dattrain), ]

finalmodel <- coxph(Surv(TIME, EXIT)~score, data=dattrain)
predictions <- survfit(finalmodel, newdata=dattest)

plot(survfit(formula=Surv(TIME, EXIT)~score, data=dattest), col=col, lwd=2,
     yaxt="n", main="Priority-Lasso", xlab="Overall survival in years", ylab="Survival probability")
axis(2, las=2)
points(predictions$time, apply(predictions$surv[ , dattest$score==0], MARGIN=1, FUN=mean), col="gray75", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==1], MARGIN=1, FUN=mean), col="gray55", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==2], MARGIN=1, FUN=mean), lty=2, type="l", lwd=2)

##
dattest <- data.frame(TIME=TIME, EXIT=EXIT, score=group_pl_ELN_cvoffset)
dattest <- dattest[complete.cases(dattest), ]
dattrain <- data.frame(TIME=TIMETrain, EXIT=EXITTrain, score=group_pl_ELN_cvoffset_train)
dattrain <- dattrain[complete.cases(dattrain), ]

finalmodel <- coxph(Surv(TIME, EXIT)~score, data=dattrain)
predictions <- survfit(finalmodel, newdata=dattest)

plot(survfit(formula=Surv(TIME, EXIT)~score, data=dattest), col=col, lwd=2,
     yaxt="n", main="Priority-Lasso\n CV offset", xlab="Overall survival in years", ylab="Survival probability")
axis(2, las=2)
points(predictions$time, apply(predictions$surv[ , dattest$score==0], MARGIN=1, FUN=mean), col="gray75", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==1], MARGIN=1, FUN=mean), col="gray55", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==2], MARGIN=1, FUN=mean), lty=2, type="l", lwd=2)

##
dattest <- data.frame(TIME=TIME, EXIT=EXIT, score=group_lasso_ELN)
dattest <- dattest[complete.cases(dattest), ]
dattrain <- data.frame(TIME=TIMETrain, EXIT=EXITTrain, score=group_lasso_ELN_train)
dattrain <- dattrain[complete.cases(dattrain), ]

finalmodel <- coxph(Surv(TIME, EXIT)~score, data=dattrain)
predictions <- survfit(finalmodel, newdata=dattest)

plot(survfit(formula=Surv(TIME, EXIT)~score, data=dattest), col=col, lwd=2,
     yaxt="n", main="Lasso", xlab="Overall survival in years", ylab="Survival probability")
axis(2, las=2)
points(predictions$time, apply(predictions$surv[ , dattest$score==0], MARGIN=1, FUN=mean), col="gray75", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==1], MARGIN=1, FUN=mean), col="gray55", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==2], MARGIN=1, FUN=mean), lty=2, type="l", lwd=2)

##
dattest <- data.frame(TIME=TIME, EXIT=EXIT, score=as.factor(pheno.test$ELN_2017))
dattest <- dattest[complete.cases(dattest), ]
eln.train <- rep(1, nrow(dattrain))
eln.train[which(pheno.train$ELN2017_2==1)] <- 2
eln.train[which(pheno.train$ELN2017_3==1)] <- 3
dattrain <- data.frame(TIME=TIMETrain, EXIT=EXITTrain, score=as.factor(eln.train))
dattrain <- dattrain[complete.cases(dattrain), ]

finalmodel <- coxph(Surv(TIME, EXIT)~score, data=dattrain)
predictions <- survfit(finalmodel, newdata=dattest)

plot(survfit(formula=Surv(TIME, EXIT)~score, data=dattest), col=col, lwd=2,
     yaxt="n", main="ELN 2017", xlab="Overall survival in years", ylab="Survival probability")
axis(2, las=2)
points(predictions$time, apply(predictions$surv[ , dattest$score==1], MARGIN=1, FUN=mean), col="gray75", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==2], MARGIN=1, FUN=mean), col="gray55", lty=2, type="l", lwd=2)
points(predictions$time,apply(predictions$surv[ , dattest$score==3], MARGIN=1, FUN=mean), lty=2, type="l", lwd=2)

plot(1:10, 1:10, col="white", xaxt="n", yaxt="n", bty="n",
     xlab="", ylab="")
legend(0.5, 10, lwd=2, lty=2, legend=c("", "", ""), cex=1.4,
       title="Predicted", col=col, bty="n")
legend(4, 10, lwd=2, legend=c("", "", ""), cex=1.4,
       title="Validation", col=col, bty="n")
legend(6, 10, legend=c("low", "intermediate", "high"), cex=1.4,
       title="", bty="n")

mtext("ELN2017 categories", side=2, outer=T, line=1, at=0.84, cex=1.2)
mtext("ELN2017 variables", side=2, outer=T, line=1, cex=1.2)
