load("data_ELN_cat.RData")
library(survival)

pheno.train <- data_ELN_cat

TIME <- pheno.train$uebleb
EXIT <- pheno.train$exit

outcome <- pheno.train$outcome
############################################

cutpoints <- function(score, outcome) {

  MIN <- quantile(score, 0.1, na.rm=T)
  MAX1 <- quantile(score, 0.8, na.rm=T)
  MAX2 <- quantile(score, 0.9, na.rm=T)

  cp1 <- round(seq(MIN, MAX1, length.out=50), 2)
  logrank <- matrix(nr=length(cp1), ncol=length(cp1))
  rownames(logrank) <- colnames(logrank) <- cp1

  for(i in 1:length(cp1)) {
    CP <- cp1[i]
    ind <- which(cp1 >= CP + 0.1)
    for(j in ind) {
      group <- rep(NA, length(score))
      group[which(score<=CP)] <- 0
      group[which(score>CP & score<=cp1[j])] <- 1
      group[which(score>cp1[j])] <- 2
      group <- factor(group, levels=c(1, 0, 2))

      model <- coxph(outcome~group)
      logrank[i, j] <- model$score
    }
  }
  index <- which(logrank==max(logrank, na.rm=T), arr.ind=T)
  ind1 <- index[1, 1]; ind2 <- index[1, 2]
  cp <- c(cp1[ind1], cp1[ind2])
  return(cp)  
}


###################################################
load("Score_pl_kat_coeff_Train.Rdata")
cp <- cutpoints(score, outcome)
save(cp, file="cutpoints_pl_kat_coeff.Rdata")

load("Score_pl_kat_cvoffset_coeff_Train.Rdata")
cp <- cutpoints(score, outcome)
save(cp, file="cutpoints_pl_kat_cvoffset_coeff.Rdata")

load("Score_lasso_kat_coeff_Train.Rdata")
cp <- cutpoints(score, outcome)
save(cp, file="cutpoints_lasso_kat_coeff.Rdata")


load("Score_pl_ELN_coeff_Train.Rdata")
cp <- cutpoints(score, outcome)
save(cp, file="cutpoints_pl_ELN_coeff.Rdata")

load("Score_pl_ELN_cvoffset_coeff_Train.Rdata")
cp <- cutpoints(score, outcome)
save(cp, file="cutpoints_pl_ELN_cvoffset_coeff.Rdata")

load("Score_lasso_ELN_coeff_Train.Rdata")
cp <- cutpoints(score, outcome)
save(cp, file="cutpoints_lasso_ELN_coeff.Rdata")

