load("test.Rdata")
load("groups_test.Rdata")

library(survival)

TIME <- pheno.test$uebleb/365.25
EXIT <- pheno.test$exit

group <- factor(group_pl_kat, levels=c(1, 0, 2))
model_pl_kat <- coxph(Surv(TIME, EXIT)~group)
summ_pl_kat <- summary(model_pl_kat)$coefficients

group <- factor(group_pl_kat_cvoffset, levels=c(1, 0, 2))
model_pl_kat_cvoffset <- coxph(Surv(TIME, EXIT)~group)
summ_pl_kat_cvoffset <- summary(model_pl_kat_cvoffset)$coefficients

group <- factor(group_lasso_kat, levels=c(1, 0, 2))
model_lasso_kat <- coxph(Surv(TIME, EXIT)~group)
summ_lasso_kat <- summary(model_lasso_kat)$coefficients

group <- factor(group_pl_ELN, levels=c(1, 0, 2))
model_pl_ELN <- coxph(Surv(TIME, EXIT)~group)
summ_pl_ELN <- summary(model_pl_ELN)$coefficients

group <- factor(group_pl_ELN_cvoffset, levels=c(1, 0, 2))
model_pl_ELN_cvoffset <- coxph(Surv(TIME, EXIT)~group)
summ_pl_ELN_cvoffset <- summary(model_pl_ELN_cvoffset)$coefficients

group <- factor(group_lasso_ELN, levels=c(1, 0, 2))
model_lasso_ELN <- coxph(Surv(TIME, EXIT)~group)
summ_lasso_ELN <- summary(model_lasso_ELN)$coefficients

group <- factor(pheno.test$ELN_2017, levels=c(2, 1, 3))
model_ELN <- coxph(Surv(TIME, EXIT)~group)
summ_ELN <- summary(model_ELN)$coefficients

HR <- matrix(nr=2, ncol=7)
HR[ ,1] <- summ_pl_kat[ ,2]
HR[ ,2] <- summ_pl_kat_cvoffset[ ,2]
HR[ ,3] <- summ_lasso_kat[ ,2]
HR[ ,4] <- summ_pl_ELN[ ,2]
HR[ ,5] <- summ_pl_ELN_cvoffset[ ,2]
HR[ ,6] <- summ_lasso_ELN[ ,2]
HR[ ,7] <- summ_ELN[ ,2]
colnames(HR) <-  c("pl1A", "pl1B", "Lasso1", "pl2A", "pl2B", "Lasso2", "ELN2017")
rownames(HR) <- c("low", "high")
HR <- round(HR, 3)

#####
CI <- matrix(nr=2, ncol=7)
CI_pl_kat <- exp(confint(model_pl_kat))
CI[ ,1] <- paste(round(CI_pl_kat[ ,1], 3), round(CI_pl_kat[ ,2], 3), sep="; ")
CI_pl_kat_cvoffset <- exp(confint(model_pl_kat_cvoffset))
CI[ ,2] <- paste(round(CI_pl_kat_cvoffset[ ,1], 3), round(CI_pl_kat_cvoffset[ ,2], 3), sep="; ")
CI_lasso_kat <- exp(confint(model_lasso_kat))
CI[ ,3] <- paste(round(CI_lasso_kat[ ,1], 3), round(CI_lasso_kat[ ,2], 3), sep="; ")
CI_pl_ELN <- exp(confint(model_pl_ELN))
CI[ ,4] <- paste(round(CI_pl_ELN[ ,1], 3), round(CI_pl_ELN[ ,2], 3), sep="; ")
CI_pl_ELN_cvoffset <- exp(confint(model_pl_ELN_cvoffset))
CI[ ,5] <- paste(round(CI_pl_ELN_cvoffset[ ,1], 3), round(CI_pl_ELN_cvoffset[ ,2], 3), sep="; ")
CI_lasso_ELN <- exp(confint(model_lasso_ELN))
CI[ ,6] <- paste(round(CI_lasso_ELN[ ,1], 3), round(CI_lasso_ELN[ ,2], 3), sep="; ")
CI_ELN <- exp(confint(model_ELN))
CI[ ,7] <- paste(round(CI_ELN[ ,1], 3), round(CI_ELN[ ,2], 3), sep="; ")

colnames(CI) <- c("pl1A", "pl1B", "Lasso1", "pl2A", "pl2B", "Lasso2", "ELN2017")
rownames(CI) <- c("low", "high")

#####
LRpvalues_groups <- c(summary(model_pl_kat)$logtest[3], summary(model_pl_kat_cvoffset)$logtest[3],
                      summary(model_lasso_kat)$logtest[3], summary(model_pl_ELN)$logtest[3], 
                      summary(model_pl_ELN_cvoffset)$logtest[3], summary(model_lasso_ELN)$logtest[3],
                      summary(model_ELN)$logtest[3])
names(LRpvalues_groups) <- colnames(HR)

save(HR, CI, LRpvalues_groups, file="Results_Risk_Groups_Restricted.Rdata")

################################################
################################################

