load("test.Rdata")
load("data_ELN_cat.RData")
pheno.train <- data_ELN_cat
outcome <- pheno.train$outcome

library(survival)

TIME <- pheno.test$uebleb/365.25
EXIT <- pheno.test$exit

TIMETrain <- outcome[ ,1]/365.25
EXITTrain <- outcome[ ,2]


#####
load("groups_test.Rdata")

test_pl_kat <- survfit(Surv(TIME, EXIT)~group_pl_kat)
test_pl_kat_cvoffset <- survfit(Surv(TIME, EXIT)~group_pl_kat_cvoffset)
test_lasso_kat <- survfit(Surv(TIME, EXIT)~group_lasso_kat)
test_pl_ELN <- survfit(Surv(TIME, EXIT)~group_pl_ELN)
test_pl_ELN_cvoffset <- survfit(Surv(TIME, EXIT)~group_pl_ELN_cvoffset)
test_lasso_ELN <- survfit(Surv(TIME, EXIT)~group_lasso_ELN)

test_ELN_test <- survfit(Surv(TIME, EXIT)~pheno.test$ELN_2017)

#####
load("groups_train.Rdata")

test_pl_kat_train <- survfit(Surv(TIMETrain, EXITTrain)~group_pl_kat_train)
test_pl_kat_cvoffset_train <- survfit(Surv(TIMETrain, EXITTrain)~group_pl_kat_cvoffset_train)
test_lasso_kat_train <- survfit(Surv(TIMETrain, EXITTrain)~group_lasso_kat_train)
test_pl_ELN_train <- survfit(Surv(TIMETrain, EXITTrain)~group_pl_ELN_train)
test_pl_ELN_cvoffset_train <- survfit(Surv(TIMETrain, EXITTrain)~group_pl_ELN_cvoffset_train)
test_lasso_ELN_train <- survfit(Surv(TIMETrain, EXITTrain)~group_lasso_ELN_train)

test_ELN_train <- survfit(Surv(TIMETrain, EXITTrain)~pheno.train$ELN2017_2 + pheno.train$ELN2017_3)

#########################################################


par(mfrow=c(3, 3), oma=c(0, 3, 0, 0))

col=c("gray75", "gray55", "black")

plot(test_pl_kat, col=col, lwd=2, yaxt="n",
     main="Priority-Lasso", xlim=c(0, 13), ylim=c(0, 1), 
     xlab="Overall survival in years", ylab="Survival probability")
axis(2, las=2)
par(new=T)
plot(test_pl_kat_train, col=col, lwd=2, lty=2,
     yaxt="n", main="", xlim=c(0, 13), ylim=c(0, 1))


plot(test_pl_kat_cvoffset, col=col, lwd=2, yaxt="n",
     main="Priority-Lasso\n CV offset", xlim=c(0, 13), ylim=c(0, 1),
     xlab="Overall survival in years", ylab="Survival probability")
axis(2, las=2)
par(new=T)
plot(test_pl_kat_cvoffset_train, col=col, lwd=2, lty=2,
     yaxt="n", main="", xlim=c(0, 13), ylim=c(0, 1))


plot(test_lasso_kat, col=col, lwd=2, main="Lasso", 
     yaxt="n", xlab="Overall survival in years", ylab="Survival probability",
     xlim=c(0, 13), ylim=c(0, 1))
axis(2, las=2)
par(new=T)
plot(test_lasso_kat_train, col=col, lwd=2, main="", lty=2,
     yaxt="n", xlim=c(0, 13), ylim=c(0, 1))


plot(test_pl_ELN, col=col, lwd=2, yaxt="n",
     xlab="Overall survival in years", ylab="Survival probability",
     main="Priority-Lasso", xlim=c(0, 13), ylim=c(0, 1))
axis(2, las=2)
par(new=T)
plot(test_pl_ELN_train, col=col, lwd=2, lty=2, yaxt="n",
     main="", xlim=c(0, 13), ylim=c(0, 1))


plot(test_pl_ELN_cvoffset, col=col, lwd=2, yaxt="n",
     xlab="Overall survival in years", ylab="Survival probability",
     main="Priority-Lasso\n CV offset", xlim=c(0, 13), ylim=c(0, 1))
axis(2, las=2)
par(new=T)
plot(test_pl_ELN_cvoffset_train, col=col, lwd=2, lty=2,
     yaxt="n", main="", xlim=c(0, 13), ylim=c(0, 1))


plot(test_lasso_ELN, col=col, lwd=2, main="Lasso", 
     yaxt="n", xlab="Overall survival in years", ylab="Survival probability",
     xlim=c(0, 13), ylim=c(0, 1))
axis(2, las=2)
par(new=T)
plot(test_lasso_ELN_train, col=col, lwd=2, main="", lty=2,
     yaxt="n", xlim=c(0, 13), ylim=c(0, 1))


plot(test_ELN_test, col=col, lwd=2, main="ELN 2017",
     xlab="Overall survival in years", ylab="Survival probability",
     xlim=c(0, 13), ylim=c(0, 1), yaxt="n")
axis(2, las=2)
par(new=T)
plot(test_ELN_train, col=c("gray75", "black", "gray55"), lwd=2, main="", lty=2,
     yaxt="n", xlim=c(0, 13), ylim=c(0, 1))


plot(1:10, 1:10, col="white", xaxt="n", yaxt="n", bty="n",
     xlab="", ylab="")
legend(0.5, 10, lwd=2, lty=2, legend=c("", "", ""), cex=1.4,
       title="Training", col=col, bty="n")
legend(3, 10, lwd=2, legend=c("", "", ""), cex=1.4,
       title="Validation", col=col, bty="n")
legend(5, 10, legend=c("low", "intermediate", "high"), cex=1.4,
       title="", bty="n")

mtext("ELN2017 categories", side=2, outer=T, line=1, at=0.84, cex=1.2)
mtext("ELN2017 variables", side=2, outer=T, line=1, cex=1.2)