library(gahgu133plus2.db)
genes <- unlist(as.list(gahgu133plus2SYMBOL))

load("test.Rdata")

pheno.test <- read.csv("Pheno_Test_Full.csv", header=T, sep=";", as.is=T)
pheno.test <- pheno.test[-259, ]


##########################################################################################
load("pl_kat_coeff.RData")
sig <- pl_kat_coeff

dd.test <- data.frame(Age=pheno.test$alter, ECOG=as.numeric(pheno.test$v02az>1), Leukos=pheno.test$v02lk, LDH=pheno.test$v02ld,
                      Hb=as.numeric(as.vector(pheno.test$v02hb)), Thrombos=pheno.test$v02th, 
                      ELN2017_2=as.numeric(pheno.test$ELN_2017==2), ELN2017_3=as.numeric(pheno.test$ELN_2017==3))
dd.test$Age <- scale(dd.test$Age); dd.test$Leukos <- scale(dd.test$Leukos); dd.test$LDH <- scale(dd.test$LDH)
dd.test$Hb <- scale(dd.test$Hb); dd.test$Thrombos <- scale(dd.test$Thrombos)


score <- as.vector(as.matrix(dd.test)[ ,names(sig)] %*% sig)
summary(score)

save(score, file="Score_pl_kat_coeff_Test.Rdata")


##########################################################################################
load("pl_kat_cvoffset_coeff.RData")
sig <- pl_kat_cvoffset_coeff

ii <- which(names(sig) %in% names(genes))
gg <- genes[names(sig)[ii]]
names(sig)[ii] <- gg

ind.mat <- which(rownames(mat.test) %in% names(sig))
ind.pheno <- which(names(pheno.test) %in% names(sig))

dd.test <- data.frame(Age=pheno.test$alter, ECOG=as.numeric(pheno.test$v02az>1), 
                      Leukos=pheno.test$v02lk, LDH=pheno.test$v02ld, Hb=as.numeric(as.vector(pheno.test$v02hb)), 
                      Thrombos=pheno.test$v02th, ELN2017_2=as.numeric(pheno.test$ELN_2017==2), 
                      ELN2017_3=as.numeric(pheno.test$ELN_2017==3), t(mat.test[ind.mat, ]))

dd.test$Age <- scale(dd.test$Age); dd.test$Leukos <- scale(dd.test$Leukos); dd.test$LDH <- scale(dd.test$LDH)
dd.test$Hb <- scale(dd.test$Hb); dd.test$Thrombos <- scale(dd.test$Thrombos)
dd.test$PRSS2 <- 0

score <- as.vector(as.matrix(dd.test)[ ,names(sig)] %*% sig)

save(score, file="Score_pl_kat_cvoffset_coeff_Test.Rdata")


##########################################################################################
load("lasso_kat_coeff.RData")
sig <- lasso_kat_coeff

ii <- which(names(sig) %in% names(genes))
gg <- genes[names(sig)[ii]]
names(sig)[ii] <- gg

ind.mat <- which(rownames(mat.test) %in% names(sig))

dd.test <- data.frame(Age=pheno.test$alter, ELN2017_3=as.numeric(pheno.test$ELN_2017==3), t(mat.test[ind.mat, ]))

dd.test$Age <- scale(dd.test$Age)

score <- as.vector(as.matrix(dd.test)[ ,names(sig)] %*% sig)

save(score, file="Score_lasso_kat_coeff_Test.Rdata")


##########################################################################################
##########################################################################################
load("pl_ELN_coeff.RData")
sig <- pl_ELN_coeff

ii <- which(names(sig) %in% names(genes))
gg <- genes[names(sig)[ii]]
names(sig)[ii] <- gg

ind.mat <- which(rownames(mat.test) %in% names(sig))
ind.pheno <- which(names(pheno.test) %in% names(sig))

dd.test <- data.frame(pheno.test[ ,ind.pheno, drop=F], Age=pheno.test$alter, ECOG=as.numeric(pheno.test$v02az>1), 
                      Leukos=pheno.test$v02lk, LDH=pheno.test$v02ld, Hb=as.numeric(as.vector(pheno.test$v02hb)), 
                      Thrombos=pheno.test$v02th, ELN2017_2=as.numeric(pheno.test$ELN_2017==2), Sex=pheno.test$sex - 1, 
                      t(mat.test[ind.mat, ]))

dd.test$Age <- scale(dd.test$Age); dd.test$Leukos <- scale(dd.test$Leukos); dd.test$LDH <- scale(dd.test$LDH)
dd.test$Hb <- scale(dd.test$Hb); dd.test$Thrombos <- scale(dd.test$Thrombos)
dd.test$OR7A17 <- 0

score <- as.vector(as.matrix(dd.test)[ ,names(sig)] %*% sig)

save(score, file="Score_pl_ELN_coeff_Test.Rdata")


##########################################################################################
load("pl_ELN_cvoffset_coeff.RData")
sig <- pl_ELN_cvoffset_coeff

ii <- which(names(sig) %in% names(genes))
gg <- genes[names(sig)[ii]]
names(sig)[ii] <- gg

ind.mat <- which(rownames(mat.test) %in% names(sig))
ind.pheno <- which(names(pheno.test) %in% names(sig))

dd.test <- data.frame(pheno.test[ ,ind.pheno, drop=F], Age=pheno.test$alter, ECOG=as.numeric(pheno.test$v02az>1), 
                      Leukos=pheno.test$v02lk, LDH=pheno.test$v02ld, Hb=as.numeric(as.vector(pheno.test$v02hb)), 
                      Thrombos=pheno.test$v02th, ELN2017_2=as.numeric(pheno.test$ELN_2017==2), 
                      t(mat.test[ind.mat, ]))

dd.test$Age <- scale(dd.test$Age); dd.test$Leukos <- scale(dd.test$Leukos); dd.test$LDH <- scale(dd.test$LDH)
dd.test$Hb <- scale(dd.test$Hb); dd.test$Thrombos <- scale(dd.test$Thrombos)

score <- as.vector(as.matrix(dd.test)[ ,names(sig)] %*% sig)

save(score, file="Score_pl_ELN_cvoffset_coeff_Test.Rdata")


##########################################################################################
load("lasso_ELN_coeff.RData")
sig <- lasso_ELN_coeff

ii <- which(names(sig) %in% names(genes))
gg <- genes[names(sig)[ii]]
names(sig)[ii] <- gg

ind.mat <- which(rownames(mat.test) %in% names(sig))

dd.test <- data.frame(Age=pheno.test$alter, t(mat.test[ind.mat, ]))

dd.test$Age <- scale(dd.test$Age)

score <- as.vector(as.matrix(dd.test)[ ,names(sig)] %*% sig)

save(score, file="Score_lasso_ELN_coeff_Test.Rdata")
