load("test.Rdata")
load("groups_test.Rdata")

library(survival); library(pec); library(timeROC); library(survC1)

TIME <- pheno.test$uebleb/365.25
EXIT <- pheno.test$exit

#####
load("Score_pl_kat_coeff_Test.Rdata")
score1 <- score
load("Score_pl_kat_cvoffset_coeff_Test.Rdata")
score2 <- score
load("Score_lasso_kat_coeff_Test.Rdata")
score3 <- score
load("Score_pl_ELN_coeff_Test.Rdata")
score4 <- score
load("Score_pl_ELN_cvoffset_coeff_Test.Rdata")
score5 <- score
load("Score_lasso_ELN_coeff_Test.Rdata")
score6 <- score
score7 <- pheno.test$ELN_2017

##### AUC
tt1 <- timeROC(TIME, delta=EXIT, cause=1, marker=score1, times=seq(1, 4, 0.5))
tt2 <- timeROC(TIME, delta=EXIT, cause=1, marker=score2, times=seq(1, 4, 0.5))
tt3 <- timeROC(TIME, delta=EXIT, cause=1, marker=score3, times=seq(1, 4, 0.5))
tt4 <- timeROC(TIME, delta=EXIT, cause=1, marker=score4, times=seq(1, 4, 0.5))
tt5 <- timeROC(TIME, delta=EXIT, cause=1, marker=score5, times=seq(1, 4, 0.5))
tt6 <- timeROC(TIME, delta=EXIT, cause=1, marker=score6, times=seq(1, 4, 0.5))
tt7 <- timeROC(TIME, delta=EXIT, cause=1, marker=score7, times=seq(1, 4, 0.5))

auc <- round(rbind(tt1$AUC, tt2$AUC, tt3$AUC, tt4$AUC, tt5$AUC, tt6$AUC, tt7$AUC), 3)
rownames(auc) <- c("pl1A", "pl1B", "Lasso1", "pl2A", "pl2B", "Lasso2", "ELN2017")
Auc <- auc[ ,"t=2"]

##### TPR, TNR
pp1 <- SeSpPPVNPV(cutpoint=median(score1, na.rm=T), T=TIME, cause=1, delta=EXIT, marker=score1, times=1:4, iid=TRUE)
pp2 <- SeSpPPVNPV(cutpoint=median(score2, na.rm=T), T=TIME, cause=1, delta=EXIT, marker=score2, times=1:4, iid=TRUE)
pp3 <- SeSpPPVNPV(cutpoint=median(score3, na.rm=T), T=TIME, cause=1, delta=EXIT, marker=score3, times=1:4, iid=TRUE)
pp4 <- SeSpPPVNPV(cutpoint=median(score4, na.rm=T), T=TIME, cause=1, delta=EXIT, marker=score4, times=1:4, iid=TRUE)
pp5 <- SeSpPPVNPV(cutpoint=median(score5, na.rm=T), T=TIME, cause=1, delta=EXIT, marker=score5, times=1:4, iid=TRUE)
pp6 <- SeSpPPVNPV(cutpoint=median(score6, na.rm=T), T=TIME, cause=1, delta=EXIT, marker=score6, times=1:4, iid=TRUE)
pp7 <- SeSpPPVNPV(cutpoint=median(score7, na.rm=T), T=TIME, cause=1, delta=EXIT, marker=score7, times=1:4, iid=TRUE)

TP <- round(c(pp1$TP[2], pp2$TP[2], pp3$TP[2], pp4$TP[2], pp5$TP[2], pp6$TP[2], pp7$TP[2]), 3)
TN <- round(c(1 - pp1$FP[2], 1 - pp2$FP[2], 1 - pp3$FP[2], 1 - pp4$FP[2], 1 - pp5$FP[2], 
              1 - pp6$FP[2], 1 - pp7$FP[2]), 3)
names(TP) <- names(TN) <- names(Auc)

##### C Uno
cUno <- rep(NA, 7)

mydata <- data.frame(TIME=TIME, EXIT=EXIT, score=score1)
mydata <- mydata[which(complete.cases(mydata)), ]
cUno[1] <- Est.Cval(mydata=mydata, tau=max(TIME), nofit=T)$Dhat

mydata <- data.frame(TIME=TIME, EXIT=EXIT, score=score2)
mydata <- mydata[which(complete.cases(mydata)), ]
cUno[2] <- Est.Cval(mydata=mydata, tau=max(TIME), nofit=T)$Dhat

mydata <- data.frame(TIME=TIME, EXIT=EXIT, score=score3)
mydata <- mydata[which(complete.cases(mydata)), ]
cUno[3] <- Est.Cval(mydata=mydata, tau=max(TIME), nofit=T)$Dhat

mydata <- data.frame(TIME=TIME, EXIT=EXIT, score=score4)
mydata <- mydata[which(complete.cases(mydata)), ]
cUno[4] <- Est.Cval(mydata=mydata, tau=max(TIME), nofit=T)$Dhat

mydata <- data.frame(TIME=TIME, EXIT=EXIT, score=score5)
mydata <- mydata[which(complete.cases(mydata)), ]
cUno[5] <- Est.Cval(mydata=mydata, tau=max(TIME), nofit=T)$Dhat

mydata <- data.frame(TIME=TIME, EXIT=EXIT, score=score6)
mydata <- mydata[which(complete.cases(mydata)), ]
cUno[6] <- Est.Cval(mydata=mydata, tau=max(TIME), nofit=T)$Dhat

mydata <- data.frame(TIME=TIME, EXIT=EXIT, pheno.test$ELN_2017)
mydata <- mydata[which(complete.cases(mydata)), ]
cUno[7] <- Est.Cval(mydata=mydata, tau=max(TIME), nofit=T)$Dhat

cUno <- round(cUno, 3)
names(cUno) <- names(Auc)

##### PECs

load("pl_kat_coeff.RData")
covars <- names(pl_kat_coeff)
load("pl_kat_cvoffset_coeff.RData")
covars <- unique(c(covars, names(pl_kat_cvoffset_coeff)))
load("lasso_kat_coeff.RData")
covars <- unique(c(covars, names(lasso_kat_coeff)))
load("pl_ELN_coeff.RData")
covars <- unique(c(covars, names(pl_ELN_coeff)))
load("pl_ELN_cvoffset_coeff.RData")
covars <- unique(c(covars, names(pl_ELN_cvoffset_coeff)))
load("lasso_ELN_coeff.RData")
covars <- unique(c(covars, names(lasso_ELN_coeff)))

library(gahgu133plus2.db)
genes <- unlist(as.list(gahgu133plus2SYMBOL))
gene.names <- genes[covars]
gene.names <- gene.names[which(!is.na(gene.names))]

ind.mat <- which(rownames(mat.test) %in% gene.names)
ind.pheno <- which(names(pheno.test) %in% covars)

# data set containing all covariables from scores 1 to 7
dat <- data.frame(TIME=TIME, EXIT=EXIT, score1=score1, score2=score2, score3=score3, 
                  score4=score4, score5=score5, score6=score6, score7=score7, pheno.test[ ,ind.pheno, drop=F],
                  t(mat.test[ind.mat, ]), ELN_2017_2=as.numeric(pheno.test$ELN_2017==2), 
                  ELN_2017_3=as.numeric(pheno.test$ELN_2017==3), Age=pheno.test$alter, 
                  ECOG=as.numeric(pheno.test$v02az>1), Leukos=pheno.test$v02lk, LDH=pheno.test$v02ld, 
                  Hb=as.numeric(as.vector(pheno.test$v02hb)), Thrombos=pheno.test$v02th, Sex=pheno.test$sex - 1)
dat$Age <- scale(dat$Age); dat$Leukos <- scale(dat$Leukos); dat$LDH <- scale(dat$LDH)
dat$Hb <- scale(dat$Hb); dat$Thrombos <- scale(dat$Thrombos)
dat$OR7A17 <- 0 # these two genes were not expressed in the RNASeq data
dat$PRSS2 <- 0
dat <- dat[complete.cases(dat), ]

formula <- as.formula(paste("Surv(TIME, EXIT)~", paste(names(dat)[10:ncol(dat)], collapse= "+")))

Models <- list("ELN 2017"=coxph(Surv(TIME, EXIT)~as.factor(score7), data=dat),
               "Priority-Lasso"=coxph(Surv(TIME, EXIT)~score1, data=dat), 
               "Priority-Lasso CV offset"=coxph(Surv(TIME, EXIT)~score2, data=dat), 
               "Lasso"=coxph(Surv(TIME, EXIT)~score3, data=dat),
               "Priority-Lasso "=coxph(Surv(TIME, EXIT)~score4, data=dat), 
               "Priority-Lasso CV offset"=coxph(Surv(TIME, EXIT)~score5, data=dat),
               "Lasso"=coxph(Surv(TIME, EXIT)~score6, data=dat))

set.seed(123)
# only ELN in categories
PredError1 <- pec(object=Models[1:4],
                  formula=formula,
                  data=dat,
                  exact=TRUE,
                  cens.model="marginal",
                  splitMethod="Boot632plus",
                  B=100,
                  verbose=TRUE)

set.seed(123)
# only models with ELN variables
PredError2 <- pec(object=Models[c(1, 5:7)],
                  formula=Surv(TIME, EXIT)~1,
                  data=dat,
                  exact=TRUE,
                  cens.model="marginal",
                  splitMethod="Boot632plus",
                  B=100,
                  verbose=TRUE)

col=c("black", "black", "grey45", "grey40", "grey70")
lty=c(3, 1, 1, 2, 1)

par(mfrow=c(1, 2))
plot(PredError1, lwd=2, xlim=c(0, 4.39), legend.cex=1.1, axes=F,
     xlab="Time in years", legend.cex=1.5, col=col, lty=lty)
axis(1); axis(2, las=2)
plot(PredError2, lwd=2, xlim=c(0, 4.39), legend.cex=1.1, axes=F,
     xlab="Time in years", col=col, lty=lty)
axis(1); axis(2, las=2)

IBS1 <- round(crps(PredError1, times=c(2, 4.39), start=0)$Boot632plusErr, 3)
IBS2 <- round(crps(PredError2, times=c(2, 4.39), start=0)$Boot632plusErr, 3)

